Package com.io7m.jregions.core.unparameterized.areas

# Interface AreaBDType

All Superinterfaces:
  `AreaSizeValuesBDType`, `AreaValuesBDType`

All Known Implementing Classes:
  `AreaBD`

    @Immutable
    public interface AreaBDType
    extends AreaValuesBDType

An area with `BigDecimal` coordinates.

The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y axis.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `default void` | `checkPreconditions()` | Check the preconditions for the parameters.
  `java.math.BigDecimal` | `maximumX()` |
  `java.math.BigDecimal` | `maximumY()` |
  `java.math.BigDecimal` | `minimumX()` |
  `java.math.BigDecimal` | `minimumY()` |

  ### Methods inherited from interface com.io7m.jregions.core.unparameterized.sizes.AreaSizeValuesBDType

  `height, width`

  ### Methods inherited from interface com.io7m.jregions.core.unparameterized.areas.AreaValuesBDType

  `sizeX, sizeY`

- ## Method Details

  - ### minimumX

    @Parameter(order=0) java.math.BigDecimal minimumX()
    Specified by:
      `minimumX` in interface `AreaValuesBDType`
    Returns:
      The value on the X axis of the minimum edge of the box (inclusive)

  - ### maximumX

    @Parameter(order=1) java.math.BigDecimal maximumX()
    Specified by:
      `maximumX` in interface `AreaValuesBDType`
    Returns:
      The value on the X axis of the maximum edge of the box (exclusive)

  - ### minimumY

    @Parameter(order=2) java.math.BigDecimal minimumY()
    Specified by:
      `minimumY` in interface `AreaValuesBDType`
    Returns:
      The value on the Y axis of the minimum edge of the box (inclusive)

  - ### maximumY

    @Parameter(order=3) java.math.BigDecimal maximumY()
    Specified by:
      `maximumY` in interface `AreaValuesBDType`
    Returns:
      The value on the Y axis of the maximum edge of the box (exclusive)

  - ### checkPreconditions

    @Check default void checkPreconditions()
    Check the preconditions for the parameters.